

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   Transparentizer 1.31                                          *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2004-08-30   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */




#ifdef __cplusplus
#define EXPORT extern "C" __declspec (dllexport)
#else
#define EXPORT __declspec (dllexport)
#endif


#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>			// ListView_GetTextBkColor, ListView_SetTextBkColor

#include "shared.h"
#include "devil_compile.h"



#pragma data_seg(".SHARED")
	HHOOK hGetMsg   = NULL;
	HWND hListView  = NULL;
	HWND hTray      = NULL;

#pragma data_seg()
#pragma comment( linker, "/section:.SHARED,rws" )



/******************************************************************************************************
**  GetMsgProc                                                                                       **
******************************************************************************************************/

LRESULT CALLBACK GetMsgProc( int iCode, WPARAM wParam, LPARAM lParam )
{
	MSG msg = *(( MSG* )lParam);

	switch( msg.message )
	{
		case WM_PAINT:
		{
			COLORREF color = ListView_GetTextBkColor( hListView );
			if( color != COLORREF_TRANSPARENT )
			{
				ListView_SetTextBkColor( hListView, COLORREF_TRANSPARENT );
				InvalidateRect( hListView, NULL, true );

				// Update original color
				PostMessage( hTray, WM_USER, JOB_TRANSPARENTIZE, ( LPARAM )color  );

				// Set icon to WORKING
				PostMessage( hTray, WM_USER, JOB_ANIMATE, 0 );
 			}

			break;
		}
	}
	return CallNextHookEx( hGetMsg, iCode, wParam, lParam );
}


/******************************************************************************************************
**  InstallHook                                                                                      **
******************************************************************************************************/

EXPORT bool InstallHook( HINSTANCE hMod, DWORD dwThreadId, HWND hListViewHandle, HWND hTrayHandle )
{
	hListView  = hListViewHandle;
	hTray      = hTrayHandle;

	hGetMsg = SetWindowsHookEx( WH_GETMESSAGE, &GetMsgProc, hMod, dwThreadId );
	return ( hGetMsg != NULL );
}


/******************************************************************************************************
**  RemoveHook                                                                                       **
******************************************************************************************************/

EXPORT void RemoveHook()
{
	UnhookWindowsHookEx( hGetMsg );
}


/******************************************************************************************************
**  FindListView                                                                                     **
******************************************************************************************************/

/*
BOOL WINAPI DllMain( HINSTANCE hInstDLL, DWORD dwReason, LPVOID pReserved )
{
	return TRUE;
}
*/