; Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>

!define PRODUCT_NAME              "Transparentizer"
!define PRODUCT_VERSION           "1.31"
!define PRODUCT_SETUP             "transparentizer_131_setup.exe"
!define PRODUCT_EXE               "Transparentizer.exe"
!define PRODUCT_README            "Readme.txt"
!define PRODUCT_UNUIST            "Uninstall.exe"

!define PRODUCT_PUBLISHER         "HARTWORK PROJECT"
!define PRODUCT_WEBSITE           "http://www.hartwork.org"
!define PRODUCT_PATH_KEY          "Software\Microsoft\Windows\CurrentVersion\App Paths\${PRODUCT_EXE}"
!define PRODUCT_UNINST_KEY        "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_STARTMENU_VAL     "NSIS:StartMenuDir"

SetCompressor lzma


!include "MUI.nsh"

!define MUI_ICON "${NSISDIR}\Source\exehead\nsis.ico"
!define MUI_UNICON "${NSISDIR}\Source\exehead\uninst.ico"

!define MUI_INSTFILESPAGE_PROGRESSBAR  ; Old-school progressbar


; **********************************************************************************
; **  Directory page
; **********************************************************************************

!insertmacro MUI_PAGE_DIRECTORY



; **********************************************************************************
; **  Start menu page
; **********************************************************************************

var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "${PRODUCT_NAME}"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME ${PRODUCT_STARTMENU_VAL}
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP



; **********************************************************************************
; **  Instfiles page
; **********************************************************************************

!insertmacro MUI_PAGE_INSTFILES


; **********************************************************************************
; **  Finish page
; **********************************************************************************

!define MUI_FINISHPAGE_RUN "$INSTDIR\${PRODUCT_EXE}"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\${PRODUCT_README}"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED

!insertmacro MUI_PAGE_FINISH



; **********************************************************************************
; **  UNINST Instfile page
; **********************************************************************************

!insertmacro MUI_UNPAGE_INSTFILES


; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS



; **********************************************************************************
; **  General
; **********************************************************************************

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "..\Release\${PRODUCT_SETUP}"
InstallDir "$PROGRAMFILES\${PRODUCT_NAME}"
BrandingText "${PRODUCT_WEBSITE}  "

InstallDirRegKey HKLM "${PRODUCT_PATH_KEY}" ""
ShowInstDetails show
ShowUnInstDetails show



; **********************************************************************************
; **  INSTALL
; **********************************************************************************

VAR HWND

Section -INSTALL
  ; Close if running
  FindWindow $HWND "TRANSPARENTIZER"
  IntCmp $HWND 0 Done
    SendMessage $HWND 16 0 0
    Sleep 1500

  Done:

  SetOutPath "$INSTDIR"
  ; SetOverwrite ifnewer

  File "..\Release\${PRODUCT_EXE}"

    File "..\Release\Progmanhook.dll"

  File "${PRODUCT_README}"
  WriteUninstaller "$INSTDIR\${PRODUCT_UNUIST}"

  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_NAME}.lnk" "$INSTDIR\${PRODUCT_EXE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Readme.lnk" "$INSTDIR\${PRODUCT_README}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\${PRODUCT_UNUIST}"

  CreateShortCut "$SMSTARTUP\${PRODUCT_NAME}.lnk" "$INSTDIR\${PRODUCT_EXE}"

  WriteRegStr HKLM "${PRODUCT_PATH_KEY}" "" "$INSTDIR\${PRODUCT_EXE}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\${PRODUCT_UNUIST}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\${PRODUCT_EXE}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_VAL}" "$ICONS_GROUP"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEBSITE}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"

SectionEnd



; **********************************************************************************
; **  UNINST
; **********************************************************************************

Section Uninstall
  ; Close if running
  FindWindow $HWND "TRANSPARENTIZER"
  IntCmp $HWND 0 Done
    SendMessage $HWND 16 0 0
    Sleep 1500

  Done:

  ReadRegStr $ICONS_GROUP HKLM "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_VAL}"

  Delete "$INSTDIR\${PRODUCT_EXE}"

    Delete "$INSTDIR\Progmanhook.dll"

  Delete "$INSTDIR\${PRODUCT_README}"
  Delete "$INSTDIR\${PRODUCT_UNUIST}"

  RMDir "$INSTDIR"

  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_NAME}.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Readme.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"

  Delete "$SMSTARTUP\${PRODUCT_NAME}.lnk"

  DeleteRegKey HKLM "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_PATH_KEY}"
  ; SetAutoClose true

SectionEnd



; **********************************************************************************
; **  UNINST Callbacks
; **********************************************************************************

; Function un.onUninstSuccess
;   HideWindow
;   MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
;
; FunctionEnd


Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
    Abort

FunctionEnd